﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.5
@EndOfDesignText@
Sub Class_Globals
	Private xui As XUI
	Private pnlCanvas1 As B4XView
	Private pnlCanvas2 As B4XView
	Private cvs1, cvs2 As B4XCanvas
	Private Rows As Int = 10
	Private Columns As Int = 20
	Private BoxSize As Int
	Private Offset As Int = 2dip
	Private pnlTouch As B4XView
	Private Boxes(Rows, Columns) As Boolean
End Sub

Public Sub Initialize (Parent As B4XView)
	Parent.LoadLayout("Layout1")
	cvs1.Initialize(pnlCanvas1)
	cvs2.Initialize(pnlCanvas2)
	BoxSize = Min((pnlCanvas1.Width - 2 * Offset) / Columns, (pnlCanvas1.Height - 2 * Offset)/ Rows)
	DrawGrid
End Sub

Private Sub DrawGrid
	cvs1.ClearRect(cvs1.TargetRect)
	For r = 0 To Rows
		cvs1.DrawLine(Offset, Offset + BoxSize * r, Offset + BoxSize * Columns, Offset + BoxSize * r, xui.Color_Black, 2dip)
	Next
	For c = 0 To Columns
		cvs1.DrawLine(Offset + BoxSize * c, Offset, Offset + BoxSize * c, Offset + BoxSize * Rows, xui.Color_Black, 2dip)
	Next
	cvs2.Invalidate
End Sub

Sub pnlTouch_MouseClicked (EventData As MouseEvent)
	Dim rc() As Int = FindBoxIndicesFromPixels(EventData.X, EventData.Y)
	Dim r As B4XRect = BoxToRect(rc(0), rc(1))
	If Boxes(rc(0), rc(1)) = True Then
		'clear box
		cvs2.ClearRect(r)
	Else
		cvs2.DrawRect(r, xui.Color_Green, True, 0)
	End If
	cvs2.Invalidate
	Boxes(rc(0), rc(1)) = Not(Boxes(rc(0), rc(1)))
End Sub

Sub pnlTouch_MouseDragged (EventData As MouseEvent)
	Dim rc() As Int = FindBoxIndicesFromPixels(EventData.X, EventData.Y)
	Dim r As B4XRect = BoxToRect(rc(0), rc(1))
	cvs2.DrawRect(r, xui.Color_Blue, True, 0)
	Boxes(rc(0), rc(1)) = True
	EventData.Consume
End Sub

Private Sub FindBoxIndicesFromPixels(x As Int, y As Int) As Int()
	Dim row As Int = Max(0, Min(Rows - 1, (y - Offset) / BoxSize))
	Dim col As Int = Max(0, Min(Columns - 1, (x - Offset) / BoxSize))
	Return Array As Int(row, col)
End Sub

Private Sub BoxToRect(r As Int, c As Int) As B4XRect
	Dim rect As B4XRect
	rect.Initialize(Offset + c * BoxSize, Offset + r * BoxSize, 0, 0)
	rect.Width = BoxSize
	rect.Height = BoxSize
	Return rect
End Sub

